// Verilog netlist produced by program LSE :  version Diamond (64-bit) 3.12.1.454
// Netlist written on Wed Feb 22 12:41:23 2023
//
// Verilog Description of module top
//

module top (Reset, KeyRows, Cathodes, Segments, LedKeyPressed) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs10/combo/source/top.v(1[8:11])
    input Reset;   // d:/lattice/kurs10/combo/source/top.v(2[17:22])
    input [3:0]KeyRows;   // d:/lattice/kurs10/combo/source/top.v(3[16:23])
    output [7:0]Cathodes;   // d:/lattice/kurs10/combo/source/top.v(4[16:24])
    output [7:0]Segments;   // d:/lattice/kurs10/combo/source/top.v(5[16:24])
    output LedKeyPressed;   // d:/lattice/kurs10/combo/source/top.v(6[17:30])
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // d:/lattice/kurs10/combo/source/top.v(11[8:13])
    
    wire GND_net, Reset_c, KeyRows_c_3, KeyRows_c_2, KeyRows_c_1, 
        KeyRows_c_0, Cathodes_c_7, Cathodes_c_6, Cathodes_c_5, Cathodes_c_4, 
        Cathodes_c_3, Cathodes_c_2, Cathodes_c_1, Cathodes_c_0, Segments_c_6, 
        Segments_c_5, Segments_c_4, Segments_c_3, Segments_c_2, Segments_c_1, 
        Segments_c_0, LedKeyPressed_c;
    wire [19:0]Data;   // d:/lattice/kurs10/combo/source/top.v(21[14:18])
    wire [4:0]KeyCode;   // d:/lattice/kurs10/combo/source/top.v(22[14:21])
    
    wire KeyStrobe, VCC_net, n1031, n2595;
    
    FD1P3AX Data_i0_i4 (.D(KeyCode[4]), .SP(KeyStrobe), .CK(Clock), .Q(Data[4]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i4.GSR = "ENABLED";
    OSCH OSCH_inst (.STDBY(GND_net), .OSC(Clock)) /* synthesis syn_instantiated=1 */ ;
    defparam OSCH_inst.NOM_FREQ = "14.00";
    FD1P3AX Data_i0_i6 (.D(Data[1]), .SP(KeyStrobe), .CK(Clock), .Q(Data[6]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i6.GSR = "ENABLED";
    FD1P3AX Data_i0_i3 (.D(KeyCode[3]), .SP(KeyStrobe), .CK(Clock), .Q(Data[3]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i3.GSR = "ENABLED";
    FD1P3AX Data_i0_i2 (.D(KeyCode[2]), .SP(KeyStrobe), .CK(Clock), .Q(Data[2]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i2.GSR = "ENABLED";
    FD1P3AX Data_i0_i1 (.D(KeyCode[1]), .SP(KeyStrobe), .CK(Clock), .Q(Data[1]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i1.GSR = "ENABLED";
    OB Cathodes_pad_7 (.I(Cathodes_c_7), .O(Cathodes[7]));   // d:/lattice/kurs10/combo/source/top.v(4[16:24])
    IB KeyRows_pad_0 (.I(KeyRows[0]), .O(KeyRows_c_0));   // d:/lattice/kurs10/combo/source/top.v(3[16:23])
    IB KeyRows_pad_1 (.I(KeyRows[1]), .O(KeyRows_c_1));   // d:/lattice/kurs10/combo/source/top.v(3[16:23])
    IB KeyRows_pad_2 (.I(KeyRows[2]), .O(KeyRows_c_2));   // d:/lattice/kurs10/combo/source/top.v(3[16:23])
    IB KeyRows_pad_3 (.I(KeyRows[3]), .O(KeyRows_c_3));   // d:/lattice/kurs10/combo/source/top.v(3[16:23])
    IB Reset_pad (.I(Reset), .O(Reset_c));   // d:/lattice/kurs10/combo/source/top.v(2[17:22])
    OB LedKeyPressed_pad (.I(LedKeyPressed_c), .O(LedKeyPressed));   // d:/lattice/kurs10/combo/source/top.v(6[17:30])
    OB Segments_pad_0 (.I(Segments_c_0), .O(Segments[0]));   // d:/lattice/kurs10/combo/source/top.v(5[16:24])
    OB Segments_pad_1 (.I(Segments_c_1), .O(Segments[1]));   // d:/lattice/kurs10/combo/source/top.v(5[16:24])
    OB Segments_pad_2 (.I(Segments_c_2), .O(Segments[2]));   // d:/lattice/kurs10/combo/source/top.v(5[16:24])
    OB Segments_pad_3 (.I(Segments_c_3), .O(Segments[3]));   // d:/lattice/kurs10/combo/source/top.v(5[16:24])
    OB Segments_pad_4 (.I(Segments_c_4), .O(Segments[4]));   // d:/lattice/kurs10/combo/source/top.v(5[16:24])
    OB Segments_pad_5 (.I(Segments_c_5), .O(Segments[5]));   // d:/lattice/kurs10/combo/source/top.v(5[16:24])
    OB Segments_pad_6 (.I(Segments_c_6), .O(Segments[6]));   // d:/lattice/kurs10/combo/source/top.v(5[16:24])
    OB Segments_pad_7 (.I(n2595), .O(Segments[7]));   // d:/lattice/kurs10/combo/source/top.v(5[16:24])
    OB Cathodes_pad_0 (.I(Cathodes_c_0), .O(Cathodes[0]));   // d:/lattice/kurs10/combo/source/top.v(4[16:24])
    OB Cathodes_pad_1 (.I(Cathodes_c_1), .O(Cathodes[1]));   // d:/lattice/kurs10/combo/source/top.v(4[16:24])
    OB Cathodes_pad_2 (.I(Cathodes_c_2), .O(Cathodes[2]));   // d:/lattice/kurs10/combo/source/top.v(4[16:24])
    OB Cathodes_pad_3 (.I(Cathodes_c_3), .O(Cathodes[3]));   // d:/lattice/kurs10/combo/source/top.v(4[16:24])
    OB Cathodes_pad_4 (.I(Cathodes_c_4), .O(Cathodes[4]));   // d:/lattice/kurs10/combo/source/top.v(4[16:24])
    OB Cathodes_pad_5 (.I(Cathodes_c_5), .O(Cathodes[5]));   // d:/lattice/kurs10/combo/source/top.v(4[16:24])
    OB Cathodes_pad_6 (.I(Cathodes_c_6), .O(Cathodes[6]));   // d:/lattice/kurs10/combo/source/top.v(4[16:24])
    FD1P3AX Data_i0_i0 (.D(KeyCode[0]), .SP(KeyStrobe), .CK(Clock), .Q(Data[0]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i0.GSR = "ENABLED";
    FD1P3AX Data_i0_i5 (.D(Data[0]), .SP(KeyStrobe), .CK(Clock), .Q(Data[5]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i5.GSR = "ENABLED";
    LUT4 i3_4_lut (.A(Data[15]), .B(Data[16]), .C(Data[17]), .D(Data[18]), 
         .Z(n1031)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam i3_4_lut.init = 16'hfffe;
    FD1P3AX Data_i0_i19 (.D(Data[14]), .SP(KeyStrobe), .CK(Clock), .Q(Data[19]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i19.GSR = "ENABLED";
    FD1P3AX Data_i0_i18 (.D(Data[13]), .SP(KeyStrobe), .CK(Clock), .Q(Data[18]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i18.GSR = "ENABLED";
    FD1P3AX Data_i0_i17 (.D(Data[12]), .SP(KeyStrobe), .CK(Clock), .Q(Data[17]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i17.GSR = "ENABLED";
    FD1P3AX Data_i0_i16 (.D(Data[11]), .SP(KeyStrobe), .CK(Clock), .Q(Data[16]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i16.GSR = "ENABLED";
    VLO i1 (.Z(GND_net));
    \DisplayMultiplex(FREQUENCY_HZ=14000000,SWITCH_PERIOD_US=2000)  DisplayMultiplex0 (.Data({Data}), 
            .Segments_c_0(Segments_c_0), .Segments_c_3(Segments_c_3), .Clock(Clock), 
            .n2595(n2595), .Cathodes_c_0(Cathodes_c_0), .Cathodes_c_7(Cathodes_c_7), 
            .Segments_c_2(Segments_c_2), .Segments_c_1(Segments_c_1), .Segments_c_4(Segments_c_4), 
            .Cathodes_c_2(Cathodes_c_2), .n1031(n1031), .Cathodes_c_3(Cathodes_c_3), 
            .Cathodes_c_5(Cathodes_c_5), .Cathodes_c_1(Cathodes_c_1), .Cathodes_c_4(Cathodes_c_4), 
            .Segments_c_6(Segments_c_6), .Cathodes_c_6(Cathodes_c_6), .Segments_c_5(Segments_c_5), 
            .GND_net(GND_net)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs10/combo/source/top.v(47[5] 54[4])
    TSALL TSALL_INST (.TSALL(GND_net));
    FD1P3AX Data_i0_i15 (.D(Data[10]), .SP(KeyStrobe), .CK(Clock), .Q(Data[15]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i15.GSR = "ENABLED";
    GSR GSR_INST (.GSR(Reset_c));
    PUR PUR_INST (.PUR(VCC_net));
    defparam PUR_INST.RST_PULSE = 1;
    FD1P3AX Data_i0_i14 (.D(Data[9]), .SP(KeyStrobe), .CK(Clock), .Q(Data[14]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i14.GSR = "ENABLED";
    FD1P3AX Data_i0_i13 (.D(Data[8]), .SP(KeyStrobe), .CK(Clock), .Q(Data[13]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i13.GSR = "ENABLED";
    FD1P3AX Data_i0_i12 (.D(Data[7]), .SP(KeyStrobe), .CK(Clock), .Q(Data[12]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i12.GSR = "ENABLED";
    FD1P3AX Data_i0_i11 (.D(Data[6]), .SP(KeyStrobe), .CK(Clock), .Q(Data[11]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i11.GSR = "ENABLED";
    FD1P3AX Data_i0_i10 (.D(Data[5]), .SP(KeyStrobe), .CK(Clock), .Q(Data[10]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i10.GSR = "ENABLED";
    FD1P3AX Data_i0_i9 (.D(Data[4]), .SP(KeyStrobe), .CK(Clock), .Q(Data[9]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i9.GSR = "ENABLED";
    FD1P3AX Data_i0_i8 (.D(Data[3]), .SP(KeyStrobe), .CK(Clock), .Q(Data[8]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i8.GSR = "ENABLED";
    FD1P3AX Data_i0_i7 (.D(Data[2]), .SP(KeyStrobe), .CK(Clock), .Q(Data[7]));   // d:/lattice/kurs10/combo/source/top.v(27[10] 28[34])
    defparam Data_i0_i7.GSR = "ENABLED";
    MatrixKeyboard MatrixKeyboard0 (.LedKeyPressed_c(LedKeyPressed_c), .KeyStrobe(KeyStrobe), 
            .Clock(Clock), .KeyCode({KeyCode}), .Cathodes_c_7(Cathodes_c_7), 
            .KeyRows_c_3(KeyRows_c_3), .KeyRows_c_2(KeyRows_c_2), .KeyRows_c_1(KeyRows_c_1), 
            .KeyRows_c_0(KeyRows_c_0), .Cathodes_c_6(Cathodes_c_6), .Cathodes_c_5(Cathodes_c_5), 
            .Cathodes_c_4(Cathodes_c_4), .Cathodes_c_3(Cathodes_c_3), .Cathodes_c_2(Cathodes_c_2), 
            .Cathodes_c_1(Cathodes_c_1), .Cathodes_c_0(Cathodes_c_0)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs10/combo/source/top.v(57[18] 65[4])
    VHI i2510 (.Z(VCC_net));
    
endmodule
//
// Verilog Description of module \DisplayMultiplex(FREQUENCY_HZ=14000000,SWITCH_PERIOD_US=2000) 
//

module \DisplayMultiplex(FREQUENCY_HZ=14000000,SWITCH_PERIOD_US=2000)  (Data, 
            Segments_c_0, Segments_c_3, Clock, n2595, Cathodes_c_0, 
            Cathodes_c_7, Segments_c_2, Segments_c_1, Segments_c_4, 
            Cathodes_c_2, n1031, Cathodes_c_3, Cathodes_c_5, Cathodes_c_1, 
            Cathodes_c_4, Segments_c_6, Cathodes_c_6, Segments_c_5, 
            GND_net) /* synthesis syn_module_defined=1 */ ;
    input [19:0]Data;
    output Segments_c_0;
    output Segments_c_3;
    input Clock;
    output n2595;
    output Cathodes_c_0;
    output Cathodes_c_7;
    output Segments_c_2;
    output Segments_c_1;
    output Segments_c_4;
    output Cathodes_c_2;
    input n1031;
    output Cathodes_c_3;
    output Cathodes_c_5;
    output Cathodes_c_1;
    output Cathodes_c_4;
    output Segments_c_6;
    output Cathodes_c_6;
    output Segments_c_5;
    input GND_net;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // d:/lattice/kurs10/combo/source/top.v(11[8:13])
    wire [31:0]TempData_3__N_34;
    
    wire n2604, n2434, n2438, n2362, n2104, n2623;
    wire [6:0]Segments_6__N_76;
    
    wire n490, n492;
    wire [3:0]TempData;   // d:/lattice/kurs10/combo/source/display_multiplex.v(55[14:22])
    
    wire n14, n2201, SwitchCathode, n2269, n7, n1032, n2622, n2820, 
        n4, n171;
    wire [2:0]n17;
    
    wire n2605, n2361, n2356, n2355, n2353, n2352, n2354, n54, 
        n2432, n179, n6, n50, n2451;
    
    LUT4 n2358_bdd_4_lut_4_lut_else_4_lut (.A(TempData_3__N_34[2]), .B(TempData_3__N_34[3]), 
         .C(Data[8]), .D(Data[3]), .Z(n2604)) /* synthesis lut_function=(!(A+!(B (C)+!B (D)))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam n2358_bdd_4_lut_4_lut_else_4_lut.init = 16'h5140;
    LUT4 gnd_bdd_2_lut_2351_3_lut (.A(n2434), .B(Data[19]), .C(n2438), 
         .Z(Segments_c_0)) /* synthesis lut_function=(A (C)+!A (B (C))) */ ;
    defparam gnd_bdd_2_lut_2351_3_lut.init = 16'he0e0;
    LUT4 i2281_3_lut (.A(Data[11]), .B(Data[16]), .C(TempData_3__N_34[3]), 
         .Z(n2362)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i2281_3_lut.init = 16'hcaca;
    LUT4 n1032_bdd_4_lut_2438 (.A(TempData_3__N_34[2]), .B(n2104), .C(Data[9]), 
         .D(Data[14]), .Z(n2623)) /* synthesis lut_function=(A (C+(D))+!A (B+(C+(D)))) */ ;
    defparam n1032_bdd_4_lut_2438.init = 16'hfff4;
    LUT4 i1398_2_lut_3_lut (.A(n2434), .B(Data[19]), .C(Segments_6__N_76[3]), 
         .Z(Segments_c_3)) /* synthesis lut_function=(A (C)+!A (B (C))) */ ;
    defparam i1398_2_lut_3_lut.init = 16'he0e0;
    LUT4 i1_4_lut_4_lut_4_lut (.A(TempData_3__N_34[2]), .B(n490), .C(n492), 
         .D(TempData[0]), .Z(n14)) /* synthesis lut_function=(!(A (D)+!A !(B+(C+!(D))))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam i1_4_lut_4_lut_4_lut.init = 16'h54ff;
    LUT4 i2120_2_lut_3_lut_4_lut (.A(n490), .B(n492), .C(TempData_3__N_34[2]), 
         .D(TempData[0]), .Z(n2201)) /* synthesis lut_function=(!(A (D)+!A (B ((D)+!C)+!B (D)))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(55[14:22])
    defparam i2120_2_lut_3_lut_4_lut.init = 16'h00fb;
    FD1P3AX Selector_270__i1 (.D(n2595), .SP(SwitchCathode), .CK(Clock), 
            .Q(TempData_3__N_34[2]));   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam Selector_270__i1.GSR = "ENABLED";
    LUT4 i2_2_lut_3_lut_4_lut (.A(n490), .B(n492), .C(TempData_3__N_34[2]), 
         .D(TempData[0]), .Z(n2269)) /* synthesis lut_function=(A+((C+(D))+!B)) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(55[14:22])
    defparam i2_2_lut_3_lut_4_lut.init = 16'hfffb;
    LUT4 Data_3__I_0_Mux_6_i7_3_lut_3_lut_4_lut (.A(TempData_3__N_34[2]), 
         .B(n490), .C(n492), .D(TempData[0]), .Z(n7)) /* synthesis lut_function=(!(A+(B (C (D))+!B !(C)))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam Data_3__I_0_Mux_6_i7_3_lut_3_lut_4_lut.init = 16'h1454;
    LUT4 n2623_bdd_4_lut (.A(n2623), .B(n1032), .C(n2622), .D(TempData_3__N_34[4]), 
         .Z(n2820)) /* synthesis lut_function=(A (C+!(D))+!A (B (C+!(D))+!B (C (D)))) */ ;
    defparam n2623_bdd_4_lut.init = 16'hf0ee;
    LUT4 i2306_2_lut_3_lut (.A(TempData_3__N_34[2]), .B(TempData_3__N_34[4]), 
         .C(TempData_3__N_34[3]), .Z(Cathodes_c_0)) /* synthesis lut_function=(!(A+(B+(C)))) */ ;
    defparam i2306_2_lut_3_lut.init = 16'h0101;
    LUT4 i1_2_lut_3_lut (.A(Data[9]), .B(n1032), .C(Data[4]), .Z(n4)) /* synthesis lut_function=(A+(B+(C))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam i1_2_lut_3_lut.init = 16'hfefe;
    LUT4 Data_31__I_0_i171_3_lut (.A(Data[10]), .B(Data[14]), .C(TempData_3__N_34[2]), 
         .Z(n171)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(55[29:48])
    defparam Data_31__I_0_i171_3_lut.init = 16'hcaca;
    LUT4 i1_2_lut_3_lut_adj_59 (.A(TempData_3__N_34[2]), .B(TempData_3__N_34[3]), 
         .C(TempData_3__N_34[4]), .Z(Cathodes_c_7)) /* synthesis lut_function=(A (B (C))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam i1_2_lut_3_lut_adj_59.init = 16'h8080;
    LUT4 i1_2_lut_3_lut_adj_60 (.A(n2434), .B(Data[19]), .C(Segments_6__N_76[2]), 
         .Z(Segments_c_2)) /* synthesis lut_function=(A (C)+!A (B (C))) */ ;
    defparam i1_2_lut_3_lut_adj_60.init = 16'he0e0;
    LUT4 i1827_2_lut_3_lut (.A(TempData_3__N_34[2]), .B(TempData_3__N_34[3]), 
         .C(TempData_3__N_34[4]), .Z(n17[2])) /* synthesis lut_function=(!(A (B (C)+!B !(C))+!A !(C))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam i1827_2_lut_3_lut.init = 16'h7878;
    PFUMX i2415 (.BLUT(n2604), .ALUT(n2605), .C0(TempData_3__N_34[4]), 
          .Z(TempData[3]));
    LUT4 i1399_2_lut_3_lut (.A(n2434), .B(Data[19]), .C(Segments_6__N_76[1]), 
         .Z(Segments_c_1)) /* synthesis lut_function=(A (C)+!A (B (C))) */ ;
    defparam i1399_2_lut_3_lut.init = 16'he0e0;
    LUT4 i1397_2_lut_3_lut (.A(n2434), .B(Data[19]), .C(Segments_6__N_76[4]), 
         .Z(Segments_c_4)) /* synthesis lut_function=(A (C)+!A (B (C))) */ ;
    defparam i1397_2_lut_3_lut.init = 16'he0e0;
    LUT4 i2280_3_lut (.A(Data[1]), .B(Data[6]), .C(TempData_3__N_34[3]), 
         .Z(n2361)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i2280_3_lut.init = 16'hcaca;
    LUT4 i1_2_lut_3_lut_adj_61 (.A(TempData_3__N_34[2]), .B(TempData_3__N_34[4]), 
         .C(TempData_3__N_34[3]), .Z(Cathodes_c_2)) /* synthesis lut_function=(!(A+(B+!(C)))) */ ;
    defparam i1_2_lut_3_lut_adj_61.init = 16'h1010;
    LUT4 i2275_3_lut (.A(Data[12]), .B(Data[17]), .C(TempData_3__N_34[3]), 
         .Z(n2356)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i2275_3_lut.init = 16'hcaca;
    LUT4 i2274_3_lut (.A(Data[2]), .B(Data[7]), .C(TempData_3__N_34[3]), 
         .Z(n2355)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i2274_3_lut.init = 16'hcaca;
    PFUMX i2282 (.BLUT(n2361), .ALUT(n2362), .C0(TempData_3__N_34[4]), 
          .Z(n490));
    LUT4 i2272_3_lut (.A(Data[5]), .B(Data[9]), .C(TempData_3__N_34[2]), 
         .Z(n2353)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i2272_3_lut.init = 16'hcaca;
    LUT4 i1820_2_lut (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[2]), 
         .Z(n17[1])) /* synthesis lut_function=(!(A (B)+!A !(B))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam i1820_2_lut.init = 16'h6666;
    LUT4 i2271_3_lut (.A(Data[0]), .B(Data[4]), .C(TempData_3__N_34[2]), 
         .Z(n2352)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;
    defparam i2271_3_lut.init = 16'hcaca;
    L6MUX21 i44 (.D0(n2354), .D1(n54), .SD(TempData_3__N_34[4]), .Z(TempData[0]));
    PFUMX i2273 (.BLUT(n2352), .ALUT(n2353), .C0(TempData_3__N_34[3]), 
          .Z(n2354));
    PFUMX i2276 (.BLUT(n2355), .ALUT(n2356), .C0(TempData_3__N_34[4]), 
          .Z(n492));
    LUT4 n2433_bdd_3_lut_4_lut (.A(n2432), .B(Data[14]), .C(TempData_3__N_34[3]), 
         .D(n2820), .Z(n2434)) /* synthesis lut_function=(A ((D)+!C)+!A (B ((D)+!C)+!B (C (D)))) */ ;
    defparam n2433_bdd_3_lut_4_lut.init = 16'hfe0e;
    LUT4 Data_31__I_0_i179_3_lut (.A(Data[15]), .B(Data[19]), .C(TempData_3__N_34[2]), 
         .Z(n179)) /* synthesis lut_function=(A (B+!(C))+!A (B (C))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(55[29:48])
    defparam Data_31__I_0_i179_3_lut.init = 16'hcaca;
    LUT4 n2358_bdd_4_lut_4_lut_then_4_lut (.A(TempData_3__N_34[2]), .B(TempData_3__N_34[3]), 
         .C(Data[18]), .D(Data[13]), .Z(n2605)) /* synthesis lut_function=(!(A+!(B (C)+!B (D)))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam n2358_bdd_4_lut_4_lut_then_4_lut.init = 16'h5140;
    LUT4 n1031_bdd_2_lut_2437 (.A(n1031), .B(TempData_3__N_34[2]), .Z(n2622)) /* synthesis lut_function=(!((B)+!A)) */ ;
    defparam n1031_bdd_2_lut_2437.init = 16'h2222;
    FD1P3AX Selector_270__i3 (.D(n17[2]), .SP(SwitchCathode), .CK(Clock), 
            .Q(TempData_3__N_34[4]));   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam Selector_270__i3.GSR = "ENABLED";
    FD1P3AX Selector_270__i2 (.D(n17[1]), .SP(SwitchCathode), .CK(Clock), 
            .Q(TempData_3__N_34[3]));   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam Selector_270__i2.GSR = "ENABLED";
    LUT4 i1_2_lut_3_lut_3_lut (.A(TempData_3__N_34[4]), .B(TempData_3__N_34[3]), 
         .C(TempData_3__N_34[2]), .Z(Cathodes_c_3)) /* synthesis lut_function=(!(A+!(B (C)))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam i1_2_lut_3_lut_3_lut.init = 16'h4040;
    LUT4 i1_2_lut_3_lut_3_lut_adj_62 (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[4]), 
         .C(TempData_3__N_34[2]), .Z(Cathodes_c_5)) /* synthesis lut_function=(!(A+!(B (C)))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam i1_2_lut_3_lut_3_lut_adj_62.init = 16'h4040;
    LUT4 i1_2_lut_3_lut_3_lut_3_lut (.A(TempData_3__N_34[3]), .B(TempData_3__N_34[2]), 
         .C(TempData_3__N_34[4]), .Z(Cathodes_c_1)) /* synthesis lut_function=(!(A+((C)+!B))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam i1_2_lut_3_lut_3_lut_3_lut.init = 16'h0404;
    LUT4 i3_4_lut (.A(Data[5]), .B(Data[8]), .C(Data[7]), .D(Data[6]), 
         .Z(n2104)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(22[39:55])
    defparam i3_4_lut.init = 16'hfffe;
    LUT4 i4_4_lut (.A(Data[10]), .B(n1031), .C(Data[12]), .D(n6), .Z(n1032)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(22[39:55])
    defparam i4_4_lut.init = 16'hfffe;
    LUT4 i1_2_lut (.A(Data[11]), .B(Data[13]), .Z(n6)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(22[39:55])
    defparam i1_2_lut.init = 16'heeee;
    LUT4 i1004_1_lut_rep_28 (.A(TempData_3__N_34[2]), .Z(n2595)) /* synthesis lut_function=(!(A)) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam i1004_1_lut_rep_28.init = 16'h5555;
    LUT4 i957_4_lut (.A(n2104), .B(n1031), .C(TempData_3__N_34[4]), .D(n4), 
         .Z(n50)) /* synthesis lut_function=(A (B+!(C))+!A (B (C+(D))+!B !(C+!(D)))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(55[14:22])
    defparam i957_4_lut.init = 16'hcfca;
    LUT4 i1_2_lut_3_lut_3_lut_3_lut_adj_63 (.A(TempData_3__N_34[2]), .B(TempData_3__N_34[4]), 
         .C(TempData_3__N_34[3]), .Z(Cathodes_c_4)) /* synthesis lut_function=(!(A+((C)+!B))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam i1_2_lut_3_lut_3_lut_3_lut_adj_63.init = 16'h0404;
    LUT4 n50_bdd_4_lut_2355 (.A(n50), .B(n1032), .C(TempData_3__N_34[4]), 
         .D(TempData_3__N_34[2]), .Z(n2432)) /* synthesis lut_function=(A (B+((D)+!C))+!A !(B (D)+!B (C+(D)))) */ ;
    defparam n50_bdd_4_lut_2355.init = 16'haacf;
    LUT4 i1395_2_lut_3_lut (.A(n2434), .B(Data[19]), .C(Segments_6__N_76[6]), 
         .Z(Segments_c_6)) /* synthesis lut_function=(A (C)+!A (B (C))) */ ;
    defparam i1395_2_lut_3_lut.init = 16'he0e0;
    LUT4 i1_2_lut_3_lut_3_lut_adj_64 (.A(TempData_3__N_34[2]), .B(TempData_3__N_34[3]), 
         .C(TempData_3__N_34[4]), .Z(Cathodes_c_6)) /* synthesis lut_function=(!(A+!(B (C)))) */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(47[21:36])
    defparam i1_2_lut_3_lut_3_lut_adj_64.init = 16'h4040;
    PFUMX i43 (.BLUT(n171), .ALUT(n179), .C0(TempData_3__N_34[3]), .Z(n54));
    LUT4 gnd_bdd_2_lut_2388_3_lut (.A(n2434), .B(Data[19]), .C(n2451), 
         .Z(Segments_c_5)) /* synthesis lut_function=(A (C)+!A (B (C))) */ ;
    defparam gnd_bdd_2_lut_2388_3_lut.init = 16'he0e0;
    \StrobeGenerator(FREQUENCY_HZ=14000000,PERIOD_US=2000)  StrobeGenerator0 (.Clock(Clock), 
            .SwitchCathode(SwitchCathode), .GND_net(GND_net)) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(31[5] 35[4])
    Decoder7seg DUT (.\TempData[0] (TempData[0]), .\TempData_3__N_34[2] (TempData_3__N_34[2]), 
            .n490(n490), .n492(n492), .\TempData[3] (TempData[3]), .\Segments_6__N_76[1] (Segments_6__N_76[1]), 
            .\Segments_6__N_76[3] (Segments_6__N_76[3]), .n2201(n2201), 
            .n14(n14), .\Segments_6__N_76[4] (Segments_6__N_76[4]), .n7(n7), 
            .n2269(n2269), .\Segments_6__N_76[6] (Segments_6__N_76[6]), 
            .n2451(n2451), .n2438(n2438), .\Segments_6__N_76[2] (Segments_6__N_76[2])) /* synthesis syn_module_defined=1 */ ;   // d:/lattice/kurs10/combo/source/display_multiplex.v(66[5] 70[4])
    
endmodule
//
// Verilog Description of module \StrobeGenerator(FREQUENCY_HZ=14000000,PERIOD_US=2000) 
//

module \StrobeGenerator(FREQUENCY_HZ=14000000,PERIOD_US=2000)  (Clock, SwitchCathode, 
            GND_net) /* synthesis syn_module_defined=1 */ ;
    input Clock;
    output SwitchCathode;
    input GND_net;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // d:/lattice/kurs10/combo/source/top.v(11[8:13])
    wire [14:0]Counter;   // d:/lattice/kurs10/combo/source/strobe_generator.v(13[19:26])
    
    wire Counter_14__N_75;
    wire [14:0]Counter_14__N_60;
    
    wire n21, n13, n20, n14, n1906, n1907, n6, n1905, n1909, 
        n1910, n1908, n1911;
    
    FD1S3JX Counter_i0 (.D(Counter_14__N_60[0]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[0])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i0.GSR = "ENABLED";
    FD1S3AX Strobe_13 (.D(Counter_14__N_75), .CK(Clock), .Q(SwitchCathode)) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Strobe_13.GSR = "ENABLED";
    LUT4 i2311_4_lut (.A(n21), .B(n13), .C(n20), .D(n14), .Z(Counter_14__N_75)) /* synthesis lut_function=(!(A+(B+(C+(D))))) */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[17:25])
    defparam i2311_4_lut.init = 16'h0001;
    LUT4 i2_2_lut (.A(Counter[3]), .B(Counter[14]), .Z(n14)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[17:25])
    defparam i2_2_lut.init = 16'heeee;
    LUT4 i8_4_lut (.A(Counter[8]), .B(Counter[2]), .C(Counter[10]), .D(Counter[9]), 
         .Z(n20)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[17:25])
    defparam i8_4_lut.init = 16'hfffe;
    CCU2D sub_6_add_2_5 (.A0(Counter[3]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[4]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n1906), .COUT(n1907), .S0(Counter_14__N_60[3]), 
          .S1(Counter_14__N_60[4]));   // d:/lattice/kurs10/combo/source/strobe_generator.v(23[14:28])
    defparam sub_6_add_2_5.INIT0 = 16'h5555;
    defparam sub_6_add_2_5.INIT1 = 16'h5555;
    defparam sub_6_add_2_5.INJECT1_0 = "NO";
    defparam sub_6_add_2_5.INJECT1_1 = "NO";
    LUT4 i2_2_lut_adj_58 (.A(Counter[7]), .B(Counter[11]), .Z(n6)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[17:25])
    defparam i2_2_lut_adj_58.init = 16'heeee;
    LUT4 i1_4_lut (.A(Counter[6]), .B(Counter[5]), .C(n6), .D(Counter[1]), 
         .Z(n13)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[17:25])
    defparam i1_4_lut.init = 16'hfffe;
    LUT4 i9_4_lut (.A(Counter[12]), .B(Counter[4]), .C(Counter[13]), .D(Counter[0]), 
         .Z(n21)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[17:25])
    defparam i9_4_lut.init = 16'hfffe;
    FD1S3JX Counter_i14 (.D(Counter_14__N_60[14]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[14])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i14.GSR = "ENABLED";
    CCU2D sub_6_add_2_3 (.A0(Counter[1]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[2]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n1905), .COUT(n1906), .S0(Counter_14__N_60[1]), 
          .S1(Counter_14__N_60[2]));   // d:/lattice/kurs10/combo/source/strobe_generator.v(23[14:28])
    defparam sub_6_add_2_3.INIT0 = 16'h5555;
    defparam sub_6_add_2_3.INIT1 = 16'h5555;
    defparam sub_6_add_2_3.INJECT1_0 = "NO";
    defparam sub_6_add_2_3.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_11 (.A0(Counter[9]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[10]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n1909), .COUT(n1910), .S0(Counter_14__N_60[9]), 
          .S1(Counter_14__N_60[10]));   // d:/lattice/kurs10/combo/source/strobe_generator.v(23[14:28])
    defparam sub_6_add_2_11.INIT0 = 16'h5555;
    defparam sub_6_add_2_11.INIT1 = 16'h5555;
    defparam sub_6_add_2_11.INJECT1_0 = "NO";
    defparam sub_6_add_2_11.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_1 (.A0(GND_net), .B0(GND_net), .C0(GND_net), .D0(GND_net), 
          .A1(Counter[0]), .B1(GND_net), .C1(GND_net), .D1(GND_net), 
          .COUT(n1905), .S1(Counter_14__N_60[0]));   // d:/lattice/kurs10/combo/source/strobe_generator.v(23[14:28])
    defparam sub_6_add_2_1.INIT0 = 16'hF000;
    defparam sub_6_add_2_1.INIT1 = 16'h5555;
    defparam sub_6_add_2_1.INJECT1_0 = "NO";
    defparam sub_6_add_2_1.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_9 (.A0(Counter[7]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[8]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n1908), .COUT(n1909), .S0(Counter_14__N_60[7]), 
          .S1(Counter_14__N_60[8]));   // d:/lattice/kurs10/combo/source/strobe_generator.v(23[14:28])
    defparam sub_6_add_2_9.INIT0 = 16'h5555;
    defparam sub_6_add_2_9.INIT1 = 16'h5555;
    defparam sub_6_add_2_9.INJECT1_0 = "NO";
    defparam sub_6_add_2_9.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_15 (.A0(Counter[13]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[14]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n1911), .S0(Counter_14__N_60[13]), .S1(Counter_14__N_60[14]));   // d:/lattice/kurs10/combo/source/strobe_generator.v(23[14:28])
    defparam sub_6_add_2_15.INIT0 = 16'h5555;
    defparam sub_6_add_2_15.INIT1 = 16'h5555;
    defparam sub_6_add_2_15.INJECT1_0 = "NO";
    defparam sub_6_add_2_15.INJECT1_1 = "NO";
    FD1S3JX Counter_i13 (.D(Counter_14__N_60[13]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[13])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i13.GSR = "ENABLED";
    FD1S3IX Counter_i12 (.D(Counter_14__N_60[12]), .CK(Clock), .CD(Counter_14__N_75), 
            .Q(Counter[12])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i12.GSR = "ENABLED";
    FD1S3JX Counter_i11 (.D(Counter_14__N_60[11]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[11])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i11.GSR = "ENABLED";
    FD1S3JX Counter_i10 (.D(Counter_14__N_60[10]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[10])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i10.GSR = "ENABLED";
    CCU2D sub_6_add_2_13 (.A0(Counter[11]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[12]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n1910), .COUT(n1911), .S0(Counter_14__N_60[11]), 
          .S1(Counter_14__N_60[12]));   // d:/lattice/kurs10/combo/source/strobe_generator.v(23[14:28])
    defparam sub_6_add_2_13.INIT0 = 16'h5555;
    defparam sub_6_add_2_13.INIT1 = 16'h5555;
    defparam sub_6_add_2_13.INJECT1_0 = "NO";
    defparam sub_6_add_2_13.INJECT1_1 = "NO";
    CCU2D sub_6_add_2_7 (.A0(Counter[5]), .B0(GND_net), .C0(GND_net), 
          .D0(GND_net), .A1(Counter[6]), .B1(GND_net), .C1(GND_net), 
          .D1(GND_net), .CIN(n1907), .COUT(n1908), .S0(Counter_14__N_60[5]), 
          .S1(Counter_14__N_60[6]));   // d:/lattice/kurs10/combo/source/strobe_generator.v(23[14:28])
    defparam sub_6_add_2_7.INIT0 = 16'h5555;
    defparam sub_6_add_2_7.INIT1 = 16'h5555;
    defparam sub_6_add_2_7.INJECT1_0 = "NO";
    defparam sub_6_add_2_7.INJECT1_1 = "NO";
    FD1S3IX Counter_i9 (.D(Counter_14__N_60[9]), .CK(Clock), .CD(Counter_14__N_75), 
            .Q(Counter[9])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i9.GSR = "ENABLED";
    FD1S3JX Counter_i8 (.D(Counter_14__N_60[8]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[8])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i8.GSR = "ENABLED";
    FD1S3IX Counter_i7 (.D(Counter_14__N_60[7]), .CK(Clock), .CD(Counter_14__N_75), 
            .Q(Counter[7])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i7.GSR = "ENABLED";
    FD1S3JX Counter_i6 (.D(Counter_14__N_60[6]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[6])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i6.GSR = "ENABLED";
    FD1S3IX Counter_i5 (.D(Counter_14__N_60[5]), .CK(Clock), .CD(Counter_14__N_75), 
            .Q(Counter[5])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i5.GSR = "ENABLED";
    FD1S3JX Counter_i4 (.D(Counter_14__N_60[4]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[4])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i4.GSR = "ENABLED";
    FD1S3JX Counter_i3 (.D(Counter_14__N_60[3]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[3])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i3.GSR = "ENABLED";
    FD1S3JX Counter_i2 (.D(Counter_14__N_60[2]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[2])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i2.GSR = "ENABLED";
    FD1S3JX Counter_i1 (.D(Counter_14__N_60[1]), .CK(Clock), .PD(Counter_14__N_75), 
            .Q(Counter[1])) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=31, LSE_RLINE=35 */ ;   // d:/lattice/kurs10/combo/source/strobe_generator.v(19[14] 25[5])
    defparam Counter_i1.GSR = "ENABLED";
    
endmodule
//
// Verilog Description of module Decoder7seg
//

module Decoder7seg (\TempData[0] , \TempData_3__N_34[2] , n490, n492, 
            \TempData[3] , \Segments_6__N_76[1] , \Segments_6__N_76[3] , 
            n2201, n14, \Segments_6__N_76[4] , n7, n2269, \Segments_6__N_76[6] , 
            n2451, n2438, \Segments_6__N_76[2] ) /* synthesis syn_module_defined=1 */ ;
    input \TempData[0] ;
    input \TempData_3__N_34[2] ;
    input n490;
    input n492;
    input \TempData[3] ;
    output \Segments_6__N_76[1] ;
    output \Segments_6__N_76[3] ;
    input n2201;
    input n14;
    output \Segments_6__N_76[4] ;
    input n7;
    input n2269;
    output \Segments_6__N_76[6] ;
    output n2451;
    output n2438;
    output \Segments_6__N_76[2] ;
    
    
    wire n2495, n2494, n7_c, n14_c, n2449, n7_adj_168, n472, n2450, 
        n2437, n2436;
    
    LUT4 TempData_2__bdd_3_lut_4_lut (.A(\TempData[0] ), .B(\TempData_3__N_34[2] ), 
         .C(n490), .D(n492), .Z(n2495)) /* synthesis lut_function=(A+(B+((D)+!C))) */ ;
    defparam TempData_2__bdd_3_lut_4_lut.init = 16'hffef;
    LUT4 TempData_2__bdd_3_lut_2371_4_lut (.A(\TempData_3__N_34[2] ), .B(n492), 
         .C(\TempData[0] ), .D(n490), .Z(n2494)) /* synthesis lut_function=(A+!(B ((D)+!C))) */ ;
    defparam TempData_2__bdd_3_lut_2371_4_lut.init = 16'hbbfb;
    LUT4 i1390_2_lut_4_lut (.A(\TempData_3__N_34[2] ), .B(\TempData[0] ), 
         .C(n490), .D(n492), .Z(n7_c)) /* synthesis lut_function=(A+(B (C+!(D))+!B !(C (D)))) */ ;
    defparam i1390_2_lut_4_lut.init = 16'hebff;
    LUT4 Data_3__I_0_Mux_1_i14_3_lut_4_lut (.A(\TempData_3__N_34[2] ), .B(n490), 
         .C(\TempData[0] ), .D(n492), .Z(n14_c)) /* synthesis lut_function=(A+!(B (C+(D))+!B !(C+!(D)))) */ ;   // d:/lattice/kurs10/combo/source/decoder_7seg.v(15[7] 33[14])
    defparam Data_3__I_0_Mux_1_i14_3_lut_4_lut.init = 16'hbabf;
    LUT4 TempData_3__bdd_4_lut_2348 (.A(\TempData[0] ), .B(n490), .C(\TempData_3__N_34[2] ), 
         .D(n492), .Z(n2449)) /* synthesis lut_function=((B+(C+!(D)))+!A) */ ;
    defparam TempData_3__bdd_4_lut_2348.init = 16'hfdff;
    LUT4 Data_3__I_0_Mux_3_i7_3_lut_4_lut (.A(\TempData_3__N_34[2] ), .B(n490), 
         .C(\TempData[0] ), .D(n492), .Z(n7_adj_168)) /* synthesis lut_function=(!(A (C)+!A (B (C (D))+!B !(C (D)+!C !(D))))) */ ;   // d:/lattice/kurs10/combo/source/decoder_7seg.v(15[7] 33[14])
    defparam Data_3__I_0_Mux_3_i7_3_lut_4_lut.init = 16'h1e4f;
    LUT4 i1391_3_lut_4_lut (.A(\TempData[0] ), .B(\TempData_3__N_34[2] ), 
         .C(n490), .D(n492), .Z(n472)) /* synthesis lut_function=(A (B+!(C (D)))+!A (B+((D)+!C))) */ ;   // d:/lattice/kurs10/combo/source/decoder_7seg.v(15[7] 33[14])
    defparam i1391_3_lut_4_lut.init = 16'hdfef;
    LUT4 TempData_3__bdd_4_lut_2364_4_lut (.A(\TempData_3__N_34[2] ), .B(n492), 
         .C(\TempData[0] ), .D(n490), .Z(n2450)) /* synthesis lut_function=(!(A (C)+!A (B (C (D))+!B (C+(D))))) */ ;
    defparam TempData_3__bdd_4_lut_2364_4_lut.init = 16'h0e4f;
    LUT4 TempData_0__bdd_4_lut_2400_4_lut (.A(\TempData[0] ), .B(\TempData_3__N_34[2] ), 
         .C(n492), .D(n490), .Z(n2437)) /* synthesis lut_function=(!(A (B+!(C+(D)))+!A !(B+((D)+!C)))) */ ;
    defparam TempData_0__bdd_4_lut_2400_4_lut.init = 16'h7765;
    LUT4 TempData_0__bdd_4_lut_2342 (.A(\TempData[0] ), .B(n490), .C(n492), 
         .D(\TempData_3__N_34[2] ), .Z(n2436)) /* synthesis lut_function=((B (C+(D))+!B ((D)+!C))+!A) */ ;
    defparam TempData_0__bdd_4_lut_2342.init = 16'hffd7;
    PFUMX Data_3__I_0_Mux_1_i15 (.BLUT(n7_c), .ALUT(n14_c), .C0(\TempData[3] ), 
          .Z(\Segments_6__N_76[1] )) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=66, LSE_RLINE=70 */ ;
    PFUMX Data_3__I_0_Mux_3_i15 (.BLUT(n7_adj_168), .ALUT(n472), .C0(\TempData[3] ), 
          .Z(\Segments_6__N_76[3] )) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=66, LSE_RLINE=70 */ ;
    PFUMX Data_3__I_0_Mux_4_i15 (.BLUT(n2201), .ALUT(n14), .C0(\TempData[3] ), 
          .Z(\Segments_6__N_76[4] )) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=66, LSE_RLINE=70 */ ;
    PFUMX Data_3__I_0_Mux_6_i15 (.BLUT(n7), .ALUT(n2269), .C0(\TempData[3] ), 
          .Z(\Segments_6__N_76[6] )) /* synthesis LSE_LINE_FILE_ID=4, LSE_LCOL=5, LSE_RCOL=4, LSE_LLINE=66, LSE_RLINE=70 */ ;
    PFUMX i2349 (.BLUT(n2450), .ALUT(n2449), .C0(\TempData[3] ), .Z(n2451));
    PFUMX i2343 (.BLUT(n2437), .ALUT(n2436), .C0(\TempData[3] ), .Z(n2438));
    PFUMX i2372 (.BLUT(n2495), .ALUT(n2494), .C0(\TempData[3] ), .Z(\Segments_6__N_76[2] ));
    
endmodule
//
// Verilog Description of module TSALL
// module not written out since it is a black-box. 
//

//
// Verilog Description of module PUR
// module not written out since it is a black-box. 
//

//
// Verilog Description of module MatrixKeyboard
//

module MatrixKeyboard (LedKeyPressed_c, KeyStrobe, Clock, KeyCode, Cathodes_c_7, 
            KeyRows_c_3, KeyRows_c_2, KeyRows_c_1, KeyRows_c_0, Cathodes_c_6, 
            Cathodes_c_5, Cathodes_c_4, Cathodes_c_3, Cathodes_c_2, 
            Cathodes_c_1, Cathodes_c_0) /* synthesis syn_module_defined=1 */ ;
    output LedKeyPressed_c;
    output KeyStrobe;
    input Clock;
    output [4:0]KeyCode;
    input Cathodes_c_7;
    input KeyRows_c_3;
    input KeyRows_c_2;
    input KeyRows_c_1;
    input KeyRows_c_0;
    input Cathodes_c_6;
    input Cathodes_c_5;
    input Cathodes_c_4;
    input Cathodes_c_3;
    input Cathodes_c_2;
    input Cathodes_c_1;
    input Cathodes_c_0;
    
    wire Clock /* synthesis SET_AS_NETWORK=Clock, is_clock=1 */ ;   // d:/lattice/kurs10/combo/source/top.v(11[8:13])
    
    wire n2590, n2584;
    wire [31:0]KeyBuffer;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(13[14:23])
    
    wire n2596, n2581, n2602, KeyPressedPrevious, KeyPressed_N_129, 
        n2601, n2585, n2583, n2588, n2593, n682, n2589, n2395, 
        n2603, n661, n10, n717, n2208, n2331, n2285, n2319, 
        n721, n2218, n17, n92, n16, n2344, n2587, n2580, n2600, 
        n4, n2591, n2222, n2346, n11, n2350, n2394, n2292, n716, 
        n2599, n2170, n89, n2052, n7, n4_adj_160, n2586, n10_adj_161, 
        n66, n10_adj_162, n603, n2291, n7_adj_163, n2579, n2592, 
        n35, n2180, n2108, n68, n9, n2300, n1492, n35_adj_164, 
        n2594, n2397, n1515, n2299, n2396, n2582, n2109, n9_adj_165, 
        n8, n519, n358, n10_adj_166, n2193, n11_adj_167, n39, 
        n2597, n46, n48, n47, n2598;
    
    LUT4 i1445_2_lut_rep_14_4_lut (.A(n2590), .B(n2584), .C(KeyBuffer[13]), 
         .D(n2596), .Z(n2581)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;
    defparam i1445_2_lut_rep_14_4_lut.init = 16'hfffe;
    LUT4 i1386_2_lut_rep_35 (.A(KeyBuffer[6]), .B(KeyBuffer[7]), .Z(n2602)) /* synthesis lut_function=(A+(B)) */ ;
    defparam i1386_2_lut_rep_35.init = 16'heeee;
    LUT4 KeyStrobe_I_0_2_lut (.A(KeyPressedPrevious), .B(LedKeyPressed_c), 
         .Z(KeyStrobe)) /* synthesis lut_function=(!(A+!(B))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(83[22:55])
    defparam KeyStrobe_I_0_2_lut.init = 16'h4444;
    FD1S3AX KeyPressed_113 (.D(KeyPressed_N_129), .CK(Clock), .Q(LedKeyPressed_c)) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(37[14] 71[8])
    defparam KeyPressed_113.GSR = "ENABLED";
    LUT4 i2_3_lut_rep_16_4_lut (.A(n2601), .B(n2585), .C(KeyBuffer[13]), 
         .D(n2590), .Z(n2583)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i2_3_lut_rep_16_4_lut.init = 16'hfffe;
    LUT4 i1_2_lut_rep_21_3_lut_4_lut (.A(KeyBuffer[6]), .B(KeyBuffer[7]), 
         .C(KeyBuffer[5]), .D(KeyBuffer[4]), .Z(n2588)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;
    defparam i1_2_lut_rep_21_3_lut_4_lut.init = 16'hfffe;
    FD1S3AX KeyPressedPrevious_114 (.D(LedKeyPressed_c), .CK(Clock), .Q(KeyPressedPrevious)) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(80[7:40])
    defparam KeyPressedPrevious_114.GSR = "ENABLED";
    LUT4 i1_2_lut_rep_17_4_lut (.A(n2593), .B(n2588), .C(n682), .D(n2601), 
         .Z(n2584)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;
    defparam i1_2_lut_rep_17_4_lut.init = 16'hfffe;
    LUT4 n1528_bdd_4_lut_2411 (.A(n2581), .B(n2589), .C(KeyBuffer[27]), 
         .D(KeyBuffer[26]), .Z(n2395)) /* synthesis lut_function=(A (C+(D))+!A (B+(C+(D)))) */ ;
    defparam n1528_bdd_4_lut_2411.init = 16'hfff4;
    LUT4 i1_2_lut_rep_36 (.A(KeyBuffer[17]), .B(KeyBuffer[16]), .Z(n2603)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_2_lut_rep_36.init = 16'heeee;
    LUT4 i5_4_lut (.A(n661), .B(n10), .C(n717), .D(n2208), .Z(n2331)) /* synthesis lut_function=(A (B+!(C (D)))+!A (B+!(C))) */ ;
    defparam i5_4_lut.init = 16'hcfef;
    LUT4 i4_4_lut (.A(n2285), .B(n2319), .C(n721), .D(n2218), .Z(n10)) /* synthesis lut_function=(A+(B+!(C (D)))) */ ;
    defparam i4_4_lut.init = 16'hefff;
    LUT4 i9_4_lut (.A(n17), .B(n92), .C(n16), .D(KeyBuffer[19]), .Z(KeyPressed_N_129)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(39[12] 70[31])
    defparam i9_4_lut.init = 16'hfffe;
    LUT4 i4_4_lut_adj_30 (.A(n2344), .B(KeyBuffer[3]), .C(n2588), .D(n2587), 
         .Z(n2319)) /* synthesis lut_function=(!(A+(B+(C+!(D))))) */ ;
    defparam i4_4_lut_adj_30.init = 16'h0100;
    LUT4 i2137_4_lut (.A(KeyBuffer[28]), .B(n2580), .C(n2600), .D(KeyBuffer[29]), 
         .Z(n2218)) /* synthesis lut_function=(A (B)+!A (B+!(C+(D)))) */ ;
    defparam i2137_4_lut.init = 16'hcccd;
    LUT4 i1_3_lut_4_lut (.A(n2601), .B(n2590), .C(n2585), .D(KeyBuffer[13]), 
         .Z(n4)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_3_lut_4_lut.init = 16'hfffe;
    LUT4 i2_3_lut_rep_18_4_lut (.A(n2602), .B(n2591), .C(n682), .D(n2593), 
         .Z(n2585)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i2_3_lut_rep_18_4_lut.init = 16'hfffe;
    LUT4 i2265_3_lut_4_lut (.A(n2602), .B(n2591), .C(n2222), .D(KeyBuffer[12]), 
         .Z(n2346)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i2265_3_lut_4_lut.init = 16'hfffe;
    LUT4 i4_3_lut_4_lut (.A(n2603), .B(KeyBuffer[18]), .C(n2591), .D(KeyBuffer[1]), 
         .Z(n11)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;
    defparam i4_3_lut_4_lut.init = 16'hfffe;
    LUT4 i2269_3_lut_4_lut (.A(n2603), .B(KeyBuffer[18]), .C(n4), .D(n2596), 
         .Z(n2350)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;
    defparam i2269_3_lut_4_lut.init = 16'hfffe;
    LUT4 n716_bdd_2_lut_3_lut_4_lut (.A(n2603), .B(KeyBuffer[18]), .C(n2583), 
         .D(n2596), .Z(n2394)) /* synthesis lut_function=(!(A (C+(D))+!A ((C+(D))+!B))) */ ;
    defparam n716_bdd_2_lut_3_lut_4_lut.init = 16'h000e;
    LUT4 i3_2_lut_3_lut_4_lut (.A(n2603), .B(KeyBuffer[18]), .C(n92), 
         .D(KeyBuffer[19]), .Z(n2292)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;
    defparam i3_2_lut_3_lut_4_lut.init = 16'hfffe;
    LUT4 i1_2_lut (.A(KeyBuffer[26]), .B(n716), .Z(n717)) /* synthesis lut_function=((B)+!A) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(65[12] 70[31])
    defparam i1_2_lut.init = 16'hdddd;
    LUT4 i1_2_lut_adj_31 (.A(KeyBuffer[3]), .B(KeyBuffer[2]), .Z(n682)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_2_lut_adj_31.init = 16'heeee;
    LUT4 i2_2_lut_3_lut_4_lut (.A(KeyBuffer[12]), .B(n2599), .C(n2585), 
         .D(n2601), .Z(n2208)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i2_2_lut_3_lut_4_lut.init = 16'hfffe;
    LUT4 i1_2_lut_rep_23_3_lut (.A(KeyBuffer[9]), .B(KeyBuffer[8]), .C(KeyBuffer[12]), 
         .Z(n2590)) /* synthesis lut_function=(A+(B+(C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_2_lut_rep_23_3_lut.init = 16'hfefe;
    LUT4 i1_4_lut (.A(n2580), .B(n2593), .C(n2170), .D(n89), .Z(n2052)) /* synthesis lut_function=(!(A (B+!(D))+!A !(B (C)+!B (C+(D))))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i1_4_lut.init = 16'h7350;
    LUT4 i1_4_lut_adj_32 (.A(KeyBuffer[3]), .B(n7), .C(n4_adj_160), .D(n2346), 
         .Z(n89)) /* synthesis lut_function=(!(A ((D)+!B)+!A !(B (C+!(D))+!B (C)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i1_4_lut_adj_32.init = 16'h50dc;
    LUT4 i2_4_lut (.A(n682), .B(n661), .C(n92), .D(n2586), .Z(n7)) /* synthesis lut_function=(!(A+!(B+!((D)+!C)))) */ ;
    defparam i2_4_lut.init = 16'h4454;
    LUT4 i1_2_lut_rep_33 (.A(KeyBuffer[31]), .B(KeyBuffer[30]), .Z(n2600)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_2_lut_rep_33.init = 16'heeee;
    LUT4 i3_2_lut_3_lut_4_lut_adj_33 (.A(KeyBuffer[9]), .B(KeyBuffer[8]), 
         .C(KeyBuffer[10]), .D(KeyBuffer[12]), .Z(n10_adj_161)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i3_2_lut_3_lut_4_lut_adj_33.init = 16'hfffe;
    LUT4 i1_2_lut_rep_20_3_lut_4_lut (.A(KeyBuffer[9]), .B(KeyBuffer[8]), 
         .C(n2601), .D(KeyBuffer[12]), .Z(n2587)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_2_lut_rep_20_3_lut_4_lut.init = 16'hfffe;
    LUT4 i1369_2_lut_rep_24 (.A(KeyBuffer[4]), .B(KeyBuffer[5]), .Z(n2591)) /* synthesis lut_function=(A+(B)) */ ;
    defparam i1369_2_lut_rep_24.init = 16'heeee;
    LUT4 i1_4_lut_adj_34 (.A(KeyBuffer[12]), .B(KeyBuffer[2]), .C(n2588), 
         .D(n2222), .Z(n4_adj_160)) /* synthesis lut_function=(!(A (B+!(C+!(D)))+!A (B+!(C)))) */ ;
    defparam i1_4_lut_adj_34.init = 16'h3032;
    LUT4 i5_4_lut_adj_35 (.A(n66), .B(n10_adj_162), .C(n603), .D(n2350), 
         .Z(n2291)) /* synthesis lut_function=(A (B+(C+!(D)))+!A (B+(C))) */ ;
    defparam i5_4_lut_adj_35.init = 16'hfcfe;
    LUT4 i4_4_lut_adj_36 (.A(n7_adj_163), .B(n717), .C(KeyBuffer[30]), 
         .D(n2579), .Z(n10_adj_162)) /* synthesis lut_function=(A+!(B ((D)+!C))) */ ;
    defparam i4_4_lut_adj_36.init = 16'hbbfb;
    LUT4 i1_4_lut_adj_37 (.A(KeyBuffer[18]), .B(n2583), .C(n2596), .D(n2603), 
         .Z(n603)) /* synthesis lut_function=(!(A (B+!(C+!(D)))+!A (B+!(C)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(62[12] 70[31])
    defparam i1_4_lut_adj_37.init = 16'h3032;
    LUT4 i1_2_lut_rep_25 (.A(KeyBuffer[24]), .B(KeyBuffer[25]), .Z(n2592)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_2_lut_rep_25.init = 16'heeee;
    LUT4 i1_3_lut (.A(KeyBuffer[15]), .B(KeyBuffer[16]), .C(KeyBuffer[17]), 
         .Z(n35)) /* synthesis lut_function=(A+!(B+!(C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(56[12] 70[31])
    defparam i1_3_lut.init = 16'hbaba;
    LUT4 i1_2_lut_3_lut (.A(KeyBuffer[24]), .B(KeyBuffer[25]), .C(n2180), 
         .Z(n2108)) /* synthesis lut_function=(A+(B+(C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_2_lut_3_lut.init = 16'hfefe;
    LUT4 i1_3_lut_adj_38 (.A(KeyBuffer[21]), .B(KeyBuffer[22]), .C(KeyBuffer[23]), 
         .Z(n68)) /* synthesis lut_function=(A+!(B+!(C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(62[12] 70[31])
    defparam i1_3_lut_adj_38.init = 16'hbaba;
    LUT4 i2_2_lut_3_lut (.A(KeyBuffer[24]), .B(KeyBuffer[25]), .C(KeyBuffer[0]), 
         .Z(n9)) /* synthesis lut_function=(A+(B+(C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i2_2_lut_3_lut.init = 16'hfefe;
    FD1P3AX KeyCode_i0_i0 (.D(n2300), .SP(KeyPressed_N_129), .CK(Clock), 
            .Q(KeyCode[0])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(37[14] 71[8])
    defparam KeyCode_i0_i0.GSR = "ENABLED";
    LUT4 i2_2_lut_rep_19_3_lut_4_lut (.A(KeyBuffer[17]), .B(KeyBuffer[16]), 
         .C(KeyBuffer[19]), .D(KeyBuffer[18]), .Z(n2586)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i2_2_lut_rep_19_3_lut_4_lut.init = 16'hfffe;
    LUT4 i1_4_lut_adj_39 (.A(n1492), .B(n35_adj_164), .C(n2593), .D(n682), 
         .Z(n7_adj_163)) /* synthesis lut_function=(!(A (B (C)+!B (C+!(D))))) */ ;
    defparam i1_4_lut_adj_39.init = 16'h5f5d;
    LUT4 i1366_2_lut_rep_26 (.A(KeyBuffer[0]), .B(KeyBuffer[1]), .Z(n2593)) /* synthesis lut_function=(A+(B)) */ ;
    defparam i1366_2_lut_rep_26.init = 16'heeee;
    LUT4 i2121_2_lut_rep_22_3_lut (.A(KeyBuffer[17]), .B(KeyBuffer[16]), 
         .C(KeyBuffer[18]), .Z(n2589)) /* synthesis lut_function=(A+(B+(C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i2121_2_lut_rep_22_3_lut.init = 16'hfefe;
    LUT4 i1_2_lut_rep_27 (.A(KeyBuffer[28]), .B(KeyBuffer[29]), .Z(n2594)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i1_2_lut_rep_27.init = 16'heeee;
    LUT4 i2141_2_lut_3_lut_4_lut (.A(KeyBuffer[10]), .B(KeyBuffer[11]), 
         .C(KeyBuffer[8]), .D(KeyBuffer[9]), .Z(n2222)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i2141_2_lut_3_lut_4_lut.init = 16'hfffe;
    LUT4 i1_2_lut_rep_34 (.A(KeyBuffer[10]), .B(KeyBuffer[11]), .Z(n2601)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_2_lut_rep_34.init = 16'heeee;
    LUT4 i4_4_lut_adj_40 (.A(n2108), .B(n2397), .C(n1515), .D(n2350), 
         .Z(n2299)) /* synthesis lut_function=(A (B+!(C (D)))+!A (B+!(C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i4_4_lut_adj_40.init = 16'hcfef;
    LUT4 i2263_2_lut_3_lut (.A(KeyBuffer[0]), .B(KeyBuffer[1]), .C(KeyBuffer[2]), 
         .Z(n2344)) /* synthesis lut_function=(A+(B+(C))) */ ;
    defparam i2263_2_lut_3_lut.init = 16'hfefe;
    LUT4 n2395_bdd_2_lut_3_lut (.A(KeyBuffer[28]), .B(KeyBuffer[29]), .C(n2395), 
         .Z(n2396)) /* synthesis lut_function=(A+(B+(C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam n2395_bdd_2_lut_3_lut.init = 16'hfefe;
    LUT4 i2_4_lut_adj_41 (.A(n2601), .B(n2591), .C(n2602), .D(n2599), 
         .Z(n35_adj_164)) /* synthesis lut_function=(!(A (B+!(C+!(D)))+!A (B+!(C)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(50[12] 70[31])
    defparam i2_4_lut_adj_41.init = 16'h3032;
    LUT4 i1_2_lut_rep_32 (.A(KeyBuffer[9]), .B(KeyBuffer[8]), .Z(n2599)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_2_lut_rep_32.init = 16'heeee;
    FD1P3AX KeyCode_i0_i4 (.D(n2299), .SP(KeyPressed_N_129), .CK(Clock), 
            .Q(KeyCode[4])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(37[14] 71[8])
    defparam KeyCode_i0_i4.GSR = "ENABLED";
    LUT4 i1_2_lut_rep_12_3_lut_4_lut (.A(KeyBuffer[27]), .B(n2582), .C(KeyBuffer[29]), 
         .D(KeyBuffer[28]), .Z(n2579)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(66[12] 70[31])
    defparam i1_2_lut_rep_12_3_lut_4_lut.init = 16'hfffe;
    FD1P3AX KeyCode_i0_i3 (.D(n2331), .SP(KeyPressed_N_129), .CK(Clock), 
            .Q(KeyCode[3])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(37[14] 71[8])
    defparam KeyCode_i0_i3.GSR = "ENABLED";
    FD1P3AX KeyCode_i0_i2 (.D(n2052), .SP(KeyPressed_N_129), .CK(Clock), 
            .Q(KeyCode[2])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(37[14] 71[8])
    defparam KeyCode_i0_i2.GSR = "ENABLED";
    FD1P3AX KeyCode_i0_i1 (.D(n2291), .SP(KeyPressed_N_129), .CK(Clock), 
            .Q(KeyCode[1])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(37[14] 71[8])
    defparam KeyCode_i0_i1.GSR = "ENABLED";
    LUT4 i1_2_lut_3_lut_4_lut (.A(KeyBuffer[31]), .B(KeyBuffer[30]), .C(KeyBuffer[29]), 
         .D(KeyBuffer[28]), .Z(n2170)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_2_lut_3_lut_4_lut.init = 16'hfffe;
    LUT4 i2_3_lut_4_lut (.A(n2596), .B(n2583), .C(n2292), .D(n2592), 
         .Z(n2285)) /* synthesis lut_function=(!(A+(B+(C+!(D))))) */ ;
    defparam i2_3_lut_4_lut.init = 16'h0100;
    LUT4 i1_2_lut_rep_15 (.A(KeyBuffer[26]), .B(n716), .Z(n2582)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(66[12] 70[31])
    defparam i1_2_lut_rep_15.init = 16'heeee;
    FD1P3AX KeyBuffer_i31 (.D(KeyRows_c_3), .SP(Cathodes_c_7), .CK(Clock), 
            .Q(KeyBuffer[31])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i31.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i30 (.D(KeyRows_c_2), .SP(Cathodes_c_7), .CK(Clock), 
            .Q(KeyBuffer[30])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i30.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i29 (.D(KeyRows_c_1), .SP(Cathodes_c_7), .CK(Clock), 
            .Q(KeyBuffer[29])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i29.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i28 (.D(KeyRows_c_0), .SP(Cathodes_c_7), .CK(Clock), 
            .Q(KeyBuffer[28])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i28.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i27 (.D(KeyRows_c_3), .SP(Cathodes_c_6), .CK(Clock), 
            .Q(KeyBuffer[27])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i27.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i26 (.D(KeyRows_c_2), .SP(Cathodes_c_6), .CK(Clock), 
            .Q(KeyBuffer[26])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i26.GSR = "ENABLED";
    LUT4 i7_4_lut (.A(KeyBuffer[30]), .B(n2602), .C(KeyBuffer[26]), .D(n2587), 
         .Z(n17)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(39[12] 70[31])
    defparam i7_4_lut.init = 16'hfffe;
    LUT4 i1_2_lut_rep_13_3_lut (.A(KeyBuffer[26]), .B(n716), .C(KeyBuffer[27]), 
         .Z(n2580)) /* synthesis lut_function=(A+(B+(C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(66[12] 70[31])
    defparam i1_2_lut_rep_13_3_lut.init = 16'hfefe;
    FD1P3AX KeyBuffer_i25 (.D(KeyRows_c_1), .SP(Cathodes_c_6), .CK(Clock), 
            .Q(KeyBuffer[25])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i25.GSR = "ENABLED";
    PFUMX i2317 (.BLUT(n2396), .ALUT(n2394), .C0(n716), .Z(n2397));
    LUT4 i6_4_lut (.A(KeyBuffer[31]), .B(n2109), .C(KeyBuffer[27]), .D(n2594), 
         .Z(n16)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(39[12] 70[31])
    defparam i6_4_lut.init = 16'hfffe;
    LUT4 i1_2_lut_3_lut_adj_42 (.A(KeyBuffer[26]), .B(n716), .C(KeyBuffer[27]), 
         .Z(n721)) /* synthesis lut_function=(A+(B+!(C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(66[12] 70[31])
    defparam i1_2_lut_3_lut_adj_42.init = 16'hefef;
    LUT4 i5_4_lut_adj_43 (.A(n9_adj_165), .B(n1492), .C(n8), .D(n519), 
         .Z(n2300)) /* synthesis lut_function=(A+((C+(D))+!B)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i5_4_lut_adj_43.init = 16'hfffb;
    LUT4 i3_4_lut (.A(KeyBuffer[24]), .B(n358), .C(n10_adj_166), .D(n2596), 
         .Z(n9_adj_165)) /* synthesis lut_function=(A (B)+!A (B+!((D)+!C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i3_4_lut.init = 16'hccdc;
    FD1P3AX KeyBuffer_i24 (.D(KeyRows_c_0), .SP(Cathodes_c_6), .CK(Clock), 
            .Q(KeyBuffer[24])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i24.GSR = "ENABLED";
    LUT4 i2_4_lut_adj_44 (.A(n4), .B(n2193), .C(n35), .D(KeyBuffer[14]), 
         .Z(n8)) /* synthesis lut_function=(A (B)+!A (B+!((D)+!C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i2_4_lut_adj_44.init = 16'hccdc;
    FD1P3AX KeyBuffer_i23 (.D(KeyRows_c_3), .SP(Cathodes_c_5), .CK(Clock), 
            .Q(KeyBuffer[23])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i23.GSR = "ENABLED";
    LUT4 i6_4_lut_adj_45 (.A(n11_adj_167), .B(n2109), .C(n10_adj_161), 
         .D(KeyBuffer[7]), .Z(n716)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i6_4_lut_adj_45.init = 16'hfffe;
    FD1P3AX KeyBuffer_i22 (.D(KeyRows_c_2), .SP(Cathodes_c_5), .CK(Clock), 
            .Q(KeyBuffer[22])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i22.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i21 (.D(KeyRows_c_1), .SP(Cathodes_c_5), .CK(Clock), 
            .Q(KeyBuffer[21])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i21.GSR = "ENABLED";
    LUT4 i1_4_lut_adj_46 (.A(KeyBuffer[19]), .B(n2350), .C(KeyBuffer[20]), 
         .D(n68), .Z(n519)) /* synthesis lut_function=(!(A (B)+!A (B+(C+!(D))))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(62[12] 70[31])
    defparam i1_4_lut_adj_46.init = 16'h2322;
    FD1P3AX KeyBuffer_i20 (.D(KeyRows_c_0), .SP(Cathodes_c_5), .CK(Clock), 
            .Q(KeyBuffer[20])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i20.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i19 (.D(KeyRows_c_3), .SP(Cathodes_c_4), .CK(Clock), 
            .Q(KeyBuffer[19])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i19.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i18 (.D(KeyRows_c_2), .SP(Cathodes_c_4), .CK(Clock), 
            .Q(KeyBuffer[18])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i18.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i17 (.D(KeyRows_c_1), .SP(Cathodes_c_4), .CK(Clock), 
            .Q(KeyBuffer[17])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i17.GSR = "ENABLED";
    LUT4 i6_4_lut_adj_47 (.A(n11), .B(n9), .C(n682), .D(n661), .Z(n2109)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i6_4_lut_adj_47.init = 16'hfffe;
    FD1P3AX KeyBuffer_i16 (.D(KeyRows_c_0), .SP(Cathodes_c_4), .CK(Clock), 
            .Q(KeyBuffer[16])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i16.GSR = "ENABLED";
    LUT4 i4_3_lut (.A(KeyBuffer[11]), .B(n2180), .C(KeyBuffer[6]), .Z(n11_adj_167)) /* synthesis lut_function=(A+(B+(C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i4_3_lut.init = 16'hfefe;
    FD1P3AX KeyBuffer_i15 (.D(KeyRows_c_3), .SP(Cathodes_c_3), .CK(Clock), 
            .Q(KeyBuffer[15])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i15.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i14 (.D(KeyRows_c_2), .SP(Cathodes_c_3), .CK(Clock), 
            .Q(KeyBuffer[14])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i14.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i13 (.D(KeyRows_c_1), .SP(Cathodes_c_3), .CK(Clock), 
            .Q(KeyBuffer[13])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i13.GSR = "ENABLED";
    LUT4 i1_4_lut_adj_48 (.A(KeyBuffer[0]), .B(KeyBuffer[1]), .C(KeyBuffer[2]), 
         .D(n39), .Z(n358)) /* synthesis lut_function=(!(A+!(B+!(C+!(D))))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(52[12] 70[31])
    defparam i1_4_lut_adj_48.init = 16'h4544;
    LUT4 i3_4_lut_adj_49 (.A(KeyBuffer[23]), .B(KeyBuffer[19]), .C(n2597), 
         .D(KeyBuffer[22]), .Z(n2180)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i3_4_lut_adj_49.init = 16'hfffe;
    LUT4 i4_4_lut_adj_50 (.A(KeyBuffer[25]), .B(n2292), .C(KeyBuffer[13]), 
         .D(n2208), .Z(n10_adj_166)) /* synthesis lut_function=(!((B+(C+(D)))+!A)) */ ;
    defparam i4_4_lut_adj_50.init = 16'h0002;
    FD1P3AX KeyBuffer_i12 (.D(KeyRows_c_0), .SP(Cathodes_c_3), .CK(Clock), 
            .Q(KeyBuffer[12])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i12.GSR = "ENABLED";
    LUT4 i1_4_lut_adj_51 (.A(KeyBuffer[3]), .B(KeyBuffer[4]), .C(KeyBuffer[5]), 
         .D(n46), .Z(n39)) /* synthesis lut_function=(A+!(B+!(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_4_lut_adj_51.init = 16'hbbba;
    FD1P3AX KeyBuffer_i11 (.D(KeyRows_c_3), .SP(Cathodes_c_2), .CK(Clock), 
            .Q(KeyBuffer[11])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i11.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i10 (.D(KeyRows_c_2), .SP(Cathodes_c_2), .CK(Clock), 
            .Q(KeyBuffer[10])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i10.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i9 (.D(KeyRows_c_1), .SP(Cathodes_c_2), .CK(Clock), 
            .Q(KeyBuffer[9])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i9.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i8 (.D(KeyRows_c_0), .SP(Cathodes_c_2), .CK(Clock), 
            .Q(KeyBuffer[8])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i8.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i7 (.D(KeyRows_c_3), .SP(Cathodes_c_1), .CK(Clock), 
            .Q(KeyBuffer[7])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i7.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i6 (.D(KeyRows_c_2), .SP(Cathodes_c_1), .CK(Clock), 
            .Q(KeyBuffer[6])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i6.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i5 (.D(KeyRows_c_1), .SP(Cathodes_c_1), .CK(Clock), 
            .Q(KeyBuffer[5])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i5.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i4 (.D(KeyRows_c_0), .SP(Cathodes_c_1), .CK(Clock), 
            .Q(KeyBuffer[4])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i4.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i3 (.D(KeyRows_c_3), .SP(Cathodes_c_0), .CK(Clock), 
            .Q(KeyBuffer[3])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i3.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i2 (.D(KeyRows_c_2), .SP(Cathodes_c_0), .CK(Clock), 
            .Q(KeyBuffer[2])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i2.GSR = "ENABLED";
    FD1P3AX KeyBuffer_i1 (.D(KeyRows_c_1), .SP(Cathodes_c_0), .CK(Clock), 
            .Q(KeyBuffer[1])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i1.GSR = "ENABLED";
    LUT4 i1410_4_lut (.A(KeyBuffer[31]), .B(n721), .C(KeyBuffer[30]), 
         .D(n2579), .Z(n1492)) /* synthesis lut_function=(A (B (C+(D)))+!A (B)) */ ;
    defparam i1410_4_lut.init = 16'hccc4;
    LUT4 i1_2_lut_rep_29 (.A(KeyBuffer[15]), .B(KeyBuffer[14]), .Z(n2596)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(39[12] 70[31])
    defparam i1_2_lut_rep_29.init = 16'heeee;
    LUT4 i1_2_lut_3_lut_adj_52 (.A(KeyBuffer[15]), .B(KeyBuffer[14]), .C(KeyBuffer[13]), 
         .Z(n661)) /* synthesis lut_function=(A+(B+(C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(39[12] 70[31])
    defparam i1_2_lut_3_lut_adj_52.init = 16'hfefe;
    LUT4 i1_2_lut_rep_30 (.A(KeyBuffer[20]), .B(KeyBuffer[21]), .Z(n2597)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i1_2_lut_rep_30.init = 16'heeee;
    LUT4 i1432_2_lut_3_lut_4_lut (.A(KeyBuffer[28]), .B(n2580), .C(n2600), 
         .D(KeyBuffer[29]), .Z(n1515)) /* synthesis lut_function=(A+(B+((D)+!C))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(68[12] 70[31])
    defparam i1432_2_lut_3_lut_4_lut.init = 16'hffef;
    LUT4 i1_4_lut_adj_53 (.A(KeyBuffer[6]), .B(KeyBuffer[7]), .C(KeyBuffer[8]), 
         .D(n48), .Z(n46)) /* synthesis lut_function=(!(A+!(B+!(C+!(D))))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(52[12] 70[31])
    defparam i1_4_lut_adj_53.init = 16'h4544;
    LUT4 i104_4_lut (.A(KeyBuffer[10]), .B(KeyBuffer[9]), .C(KeyBuffer[11]), 
         .D(n47), .Z(n48)) /* synthesis lut_function=(A (B)+!A (B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(13[14:23])
    defparam i104_4_lut.init = 16'hdddc;
    FD1P3AX KeyBuffer_i0 (.D(KeyRows_c_0), .SP(Cathodes_c_0), .CK(Clock), 
            .Q(KeyBuffer[0])) /* synthesis LSE_LINE_FILE_ID=6, LSE_LCOL=18, LSE_RCOL=4, LSE_LLINE=57, LSE_RLINE=65 */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam KeyBuffer_i0.GSR = "ENABLED";
    LUT4 i1_2_lut_3_lut_4_lut_adj_54 (.A(KeyBuffer[27]), .B(n2582), .C(KeyBuffer[29]), 
         .D(KeyBuffer[28]), .Z(n2193)) /* synthesis lut_function=(!(A+(B+((D)+!C)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(66[12] 70[31])
    defparam i1_2_lut_3_lut_4_lut_adj_54.init = 16'h0010;
    LUT4 i1_3_lut_4_lut_adj_55 (.A(KeyBuffer[20]), .B(KeyBuffer[21]), .C(n2598), 
         .D(KeyBuffer[19]), .Z(n66)) /* synthesis lut_function=(A (D)+!A (B (D)+!B (C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(70[12:31])
    defparam i1_3_lut_4_lut_adj_55.init = 16'hff10;
    LUT4 i1_2_lut_adj_56 (.A(KeyBuffer[13]), .B(KeyBuffer[12]), .Z(n47)) /* synthesis lut_function=(!((B)+!A)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(13[14:23])
    defparam i1_2_lut_adj_56.init = 16'h2222;
    LUT4 i1_2_lut_rep_31 (.A(KeyBuffer[22]), .B(KeyBuffer[23]), .Z(n2598)) /* synthesis lut_function=(A+(B)) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_2_lut_rep_31.init = 16'heeee;
    LUT4 i1_2_lut_3_lut_4_lut_adj_57 (.A(KeyBuffer[22]), .B(KeyBuffer[23]), 
         .C(KeyBuffer[21]), .D(KeyBuffer[20]), .Z(n92)) /* synthesis lut_function=(A+(B+(C+(D)))) */ ;   // d:/lattice/kurs10/combo/source/matrix_keyboard.v(19[10] 28[8])
    defparam i1_2_lut_3_lut_4_lut_adj_57.init = 16'hfffe;
    
endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 6.5 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type bram -wp 10 -rp 0011 -data_width 1 -num_rows 2 -rdata_width 1 -read_reg1 outreg -gsr DISABLED -reset_rel async -memformat bin -cascade -1 -n pmi_ram_dpXbnonesadr11211211401afe -pmi -lang verilog  */
/* Sun Feb 26 11:38:21 2023 */


`timescale 1 ns / 1 ps
module pmi_ram_dpXbnonesadr11211211401afe (WrAddress, RdAddress, Data, 
    WE, RdClock, RdClockEn, Reset, WrClock, WrClockEn, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [0:0] WrAddress;
    input wire [0:0] RdAddress;
    input wire [0:0] Data;
    input wire WE;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    input wire WrClock;
    input wire WrClockEn;
    output wire [0:0] Q;

    wire scuba_vhi;
    wire scuba_vlo;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam pmi_ram_dpXbnonesadr11211211401afe_0_0_0.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr11211211401afe_0_0_0.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr11211211401afe_0_0_0.CSDECODE_B = "0b000" ;
    defparam pmi_ram_dpXbnonesadr11211211401afe_0_0_0.CSDECODE_A = "0b000" ;
    defparam pmi_ram_dpXbnonesadr11211211401afe_0_0_0.WRITEMODE_B = "NORMAL" ;
    defparam pmi_ram_dpXbnonesadr11211211401afe_0_0_0.WRITEMODE_A = "NORMAL" ;
    defparam pmi_ram_dpXbnonesadr11211211401afe_0_0_0.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr11211211401afe_0_0_0.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr11211211401afe_0_0_0.REGMODE_B = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr11211211401afe_0_0_0.REGMODE_A = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr11211211401afe_0_0_0.DATA_WIDTH_B = 1 ;
    defparam pmi_ram_dpXbnonesadr11211211401afe_0_0_0.DATA_WIDTH_A = 1 ;
    DP8KC pmi_ram_dpXbnonesadr11211211401afe_0_0_0 (.DIA8(scuba_vlo), .DIA7(scuba_vlo), 
        .DIA6(scuba_vlo), .DIA5(scuba_vlo), .DIA4(scuba_vlo), .DIA3(scuba_vlo), 
        .DIA2(scuba_vlo), .DIA1(Data[0]), .DIA0(scuba_vlo), .ADA12(scuba_vlo), 
        .ADA11(scuba_vlo), .ADA10(scuba_vlo), .ADA9(scuba_vlo), .ADA8(scuba_vlo), 
        .ADA7(scuba_vlo), .ADA6(scuba_vlo), .ADA5(scuba_vlo), .ADA4(scuba_vlo), 
        .ADA3(scuba_vlo), .ADA2(scuba_vlo), .ADA1(scuba_vlo), .ADA0(WrAddress[0]), 
        .CEA(WrClockEn), .OCEA(WrClockEn), .CLKA(WrClock), .WEA(WE), .CSA2(scuba_vlo), 
        .CSA1(scuba_vlo), .CSA0(scuba_vlo), .RSTA(Reset), .DIB8(scuba_vlo), 
        .DIB7(scuba_vlo), .DIB6(scuba_vlo), .DIB5(scuba_vlo), .DIB4(scuba_vlo), 
        .DIB3(scuba_vlo), .DIB2(scuba_vlo), .DIB1(scuba_vlo), .DIB0(scuba_vlo), 
        .ADB12(scuba_vlo), .ADB11(scuba_vlo), .ADB10(scuba_vlo), .ADB9(scuba_vlo), 
        .ADB8(scuba_vlo), .ADB7(scuba_vlo), .ADB6(scuba_vlo), .ADB5(scuba_vlo), 
        .ADB4(scuba_vlo), .ADB3(scuba_vlo), .ADB2(scuba_vlo), .ADB1(scuba_vlo), 
        .ADB0(RdAddress[0]), .CEB(RdClockEn), .OCEB(RdClockEn), .CLKB(RdClock), 
        .WEB(scuba_vlo), .CSB2(scuba_vlo), .CSB1(scuba_vlo), .CSB0(scuba_vlo), 
        .RSTB(Reset), .DOA8(), .DOA7(), .DOA6(), .DOA5(), .DOA4(), .DOA3(), 
        .DOA2(), .DOA1(), .DOA0(), .DOB8(), .DOB7(), .DOB6(), .DOB5(), .DOB4(), 
        .DOB3(), .DOB2(), .DOB1(), .DOB0(Q[0]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr11211211401afe__PMIP__2__1__1B" */
             /* synthesis MEM_INIT_FILE="" */;



    // exemplar begin
    // exemplar attribute pmi_ram_dpXbnonesadr11211211401afe_0_0_0 MEM_LPC_FILE pmi_ram_dpXbnonesadr11211211401afe__PMIP__2__1__1B
    // exemplar attribute pmi_ram_dpXbnonesadr11211211401afe_0_0_0 MEM_INIT_FILE 
    // exemplar end

endmodule
/* Verilog netlist generated by SCUBA Diamond (64-bit) 3.12.1.454 */
/* Module Version: 6.5 */
/* D:/Lattice/diamond/3.12/ispfpga/bin/nt64/scuba -w -bus_exp 7 -bb -arch xo2c00 -type bram -wp 10 -rp 0011 -data_width 73 -num_rows 16 -rdata_width 73 -read_reg1 outreg -gsr DISABLED -reset_rel async -memformat bin -cascade -1 -n pmi_ram_dpXbnonesadr73416734161188786e -pmi -lang verilog  */
/* Sun Feb 26 11:38:21 2023 */


`timescale 1 ns / 1 ps
module pmi_ram_dpXbnonesadr73416734161188786e (WrAddress, RdAddress, 
    Data, WE, RdClock, RdClockEn, Reset, WrClock, WrClockEn, Q)/* synthesis NGD_DRC_MASK=1 */;
    input wire [3:0] WrAddress;
    input wire [3:0] RdAddress;
    input wire [72:0] Data;
    input wire WE;
    input wire RdClock;
    input wire RdClockEn;
    input wire Reset;
    input wire WrClock;
    input wire WrClockEn;
    output wire [72:0] Q;

    wire scuba_vhi;
    wire scuba_vlo;

    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_0_4.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_0_4.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_0_4.CSDECODE_R = "0b000" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_0_4.CSDECODE_W = "0b001" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_0_4.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_0_4.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_0_4.REGMODE = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_0_4.DATA_WIDTH_R = 18 ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_0_4.DATA_WIDTH_W = 18 ;
    PDPW8KC pmi_ram_dpXbnonesadr73416734161188786e_0_0_4 (.DI17(Data[17]), 
        .DI16(Data[16]), .DI15(Data[15]), .DI14(Data[14]), .DI13(Data[13]), 
        .DI12(Data[12]), .DI11(Data[11]), .DI10(Data[10]), .DI9(Data[9]), 
        .DI8(Data[8]), .DI7(Data[7]), .DI6(Data[6]), .DI5(Data[5]), .DI4(Data[4]), 
        .DI3(Data[3]), .DI2(Data[2]), .DI1(Data[1]), .DI0(Data[0]), .ADW8(scuba_vlo), 
        .ADW7(scuba_vlo), .ADW6(scuba_vlo), .ADW5(scuba_vlo), .ADW4(scuba_vlo), 
        .ADW3(WrAddress[3]), .ADW2(WrAddress[2]), .ADW1(WrAddress[1]), .ADW0(WrAddress[0]), 
        .BE1(scuba_vhi), .BE0(scuba_vhi), .CEW(WrClockEn), .CLKW(WrClock), 
        .CSW2(scuba_vlo), .CSW1(scuba_vlo), .CSW0(WE), .ADR12(scuba_vlo), 
        .ADR11(scuba_vlo), .ADR10(scuba_vlo), .ADR9(scuba_vlo), .ADR8(scuba_vlo), 
        .ADR7(RdAddress[3]), .ADR6(RdAddress[2]), .ADR5(RdAddress[1]), .ADR4(RdAddress[0]), 
        .ADR3(scuba_vlo), .ADR2(scuba_vlo), .ADR1(scuba_vlo), .ADR0(scuba_vlo), 
        .CER(RdClockEn), .OCER(RdClockEn), .CLKR(RdClock), .CSR2(scuba_vlo), 
        .CSR1(scuba_vlo), .CSR0(scuba_vlo), .RST(Reset), .DO17(Q[8]), .DO16(Q[7]), 
        .DO15(Q[6]), .DO14(Q[5]), .DO13(Q[4]), .DO12(Q[3]), .DO11(Q[2]), 
        .DO10(Q[1]), .DO9(Q[0]), .DO8(Q[17]), .DO7(Q[16]), .DO6(Q[15]), 
        .DO5(Q[14]), .DO4(Q[13]), .DO3(Q[12]), .DO2(Q[11]), .DO1(Q[10]), 
        .DO0(Q[9]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr73416734161188786e__PMIP__16__73__73B" */
             /* synthesis MEM_INIT_FILE="" */;

    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_1_3.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_1_3.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_1_3.CSDECODE_R = "0b000" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_1_3.CSDECODE_W = "0b001" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_1_3.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_1_3.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_1_3.REGMODE = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_1_3.DATA_WIDTH_R = 18 ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_1_3.DATA_WIDTH_W = 18 ;
    PDPW8KC pmi_ram_dpXbnonesadr73416734161188786e_0_1_3 (.DI17(Data[35]), 
        .DI16(Data[34]), .DI15(Data[33]), .DI14(Data[32]), .DI13(Data[31]), 
        .DI12(Data[30]), .DI11(Data[29]), .DI10(Data[28]), .DI9(Data[27]), 
        .DI8(Data[26]), .DI7(Data[25]), .DI6(Data[24]), .DI5(Data[23]), 
        .DI4(Data[22]), .DI3(Data[21]), .DI2(Data[20]), .DI1(Data[19]), 
        .DI0(Data[18]), .ADW8(scuba_vlo), .ADW7(scuba_vlo), .ADW6(scuba_vlo), 
        .ADW5(scuba_vlo), .ADW4(scuba_vlo), .ADW3(WrAddress[3]), .ADW2(WrAddress[2]), 
        .ADW1(WrAddress[1]), .ADW0(WrAddress[0]), .BE1(scuba_vhi), .BE0(scuba_vhi), 
        .CEW(WrClockEn), .CLKW(WrClock), .CSW2(scuba_vlo), .CSW1(scuba_vlo), 
        .CSW0(WE), .ADR12(scuba_vlo), .ADR11(scuba_vlo), .ADR10(scuba_vlo), 
        .ADR9(scuba_vlo), .ADR8(scuba_vlo), .ADR7(RdAddress[3]), .ADR6(RdAddress[2]), 
        .ADR5(RdAddress[1]), .ADR4(RdAddress[0]), .ADR3(scuba_vlo), .ADR2(scuba_vlo), 
        .ADR1(scuba_vlo), .ADR0(scuba_vlo), .CER(RdClockEn), .OCER(RdClockEn), 
        .CLKR(RdClock), .CSR2(scuba_vlo), .CSR1(scuba_vlo), .CSR0(scuba_vlo), 
        .RST(Reset), .DO17(Q[26]), .DO16(Q[25]), .DO15(Q[24]), .DO14(Q[23]), 
        .DO13(Q[22]), .DO12(Q[21]), .DO11(Q[20]), .DO10(Q[19]), .DO9(Q[18]), 
        .DO8(Q[35]), .DO7(Q[34]), .DO6(Q[33]), .DO5(Q[32]), .DO4(Q[31]), 
        .DO3(Q[30]), .DO2(Q[29]), .DO1(Q[28]), .DO0(Q[27]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr73416734161188786e__PMIP__16__73__73B" */
             /* synthesis MEM_INIT_FILE="" */;

    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_2_2.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_2_2.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_2_2.CSDECODE_R = "0b000" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_2_2.CSDECODE_W = "0b001" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_2_2.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_2_2.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_2_2.REGMODE = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_2_2.DATA_WIDTH_R = 18 ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_2_2.DATA_WIDTH_W = 18 ;
    PDPW8KC pmi_ram_dpXbnonesadr73416734161188786e_0_2_2 (.DI17(Data[53]), 
        .DI16(Data[52]), .DI15(Data[51]), .DI14(Data[50]), .DI13(Data[49]), 
        .DI12(Data[48]), .DI11(Data[47]), .DI10(Data[46]), .DI9(Data[45]), 
        .DI8(Data[44]), .DI7(Data[43]), .DI6(Data[42]), .DI5(Data[41]), 
        .DI4(Data[40]), .DI3(Data[39]), .DI2(Data[38]), .DI1(Data[37]), 
        .DI0(Data[36]), .ADW8(scuba_vlo), .ADW7(scuba_vlo), .ADW6(scuba_vlo), 
        .ADW5(scuba_vlo), .ADW4(scuba_vlo), .ADW3(WrAddress[3]), .ADW2(WrAddress[2]), 
        .ADW1(WrAddress[1]), .ADW0(WrAddress[0]), .BE1(scuba_vhi), .BE0(scuba_vhi), 
        .CEW(WrClockEn), .CLKW(WrClock), .CSW2(scuba_vlo), .CSW1(scuba_vlo), 
        .CSW0(WE), .ADR12(scuba_vlo), .ADR11(scuba_vlo), .ADR10(scuba_vlo), 
        .ADR9(scuba_vlo), .ADR8(scuba_vlo), .ADR7(RdAddress[3]), .ADR6(RdAddress[2]), 
        .ADR5(RdAddress[1]), .ADR4(RdAddress[0]), .ADR3(scuba_vlo), .ADR2(scuba_vlo), 
        .ADR1(scuba_vlo), .ADR0(scuba_vlo), .CER(RdClockEn), .OCER(RdClockEn), 
        .CLKR(RdClock), .CSR2(scuba_vlo), .CSR1(scuba_vlo), .CSR0(scuba_vlo), 
        .RST(Reset), .DO17(Q[44]), .DO16(Q[43]), .DO15(Q[42]), .DO14(Q[41]), 
        .DO13(Q[40]), .DO12(Q[39]), .DO11(Q[38]), .DO10(Q[37]), .DO9(Q[36]), 
        .DO8(Q[53]), .DO7(Q[52]), .DO6(Q[51]), .DO5(Q[50]), .DO4(Q[49]), 
        .DO3(Q[48]), .DO2(Q[47]), .DO1(Q[46]), .DO0(Q[45]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr73416734161188786e__PMIP__16__73__73B" */
             /* synthesis MEM_INIT_FILE="" */;

    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_3_1.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_3_1.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_3_1.CSDECODE_R = "0b000" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_3_1.CSDECODE_W = "0b001" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_3_1.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_3_1.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_3_1.REGMODE = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_3_1.DATA_WIDTH_R = 18 ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_3_1.DATA_WIDTH_W = 18 ;
    PDPW8KC pmi_ram_dpXbnonesadr73416734161188786e_0_3_1 (.DI17(Data[71]), 
        .DI16(Data[70]), .DI15(Data[69]), .DI14(Data[68]), .DI13(Data[67]), 
        .DI12(Data[66]), .DI11(Data[65]), .DI10(Data[64]), .DI9(Data[63]), 
        .DI8(Data[62]), .DI7(Data[61]), .DI6(Data[60]), .DI5(Data[59]), 
        .DI4(Data[58]), .DI3(Data[57]), .DI2(Data[56]), .DI1(Data[55]), 
        .DI0(Data[54]), .ADW8(scuba_vlo), .ADW7(scuba_vlo), .ADW6(scuba_vlo), 
        .ADW5(scuba_vlo), .ADW4(scuba_vlo), .ADW3(WrAddress[3]), .ADW2(WrAddress[2]), 
        .ADW1(WrAddress[1]), .ADW0(WrAddress[0]), .BE1(scuba_vhi), .BE0(scuba_vhi), 
        .CEW(WrClockEn), .CLKW(WrClock), .CSW2(scuba_vlo), .CSW1(scuba_vlo), 
        .CSW0(WE), .ADR12(scuba_vlo), .ADR11(scuba_vlo), .ADR10(scuba_vlo), 
        .ADR9(scuba_vlo), .ADR8(scuba_vlo), .ADR7(RdAddress[3]), .ADR6(RdAddress[2]), 
        .ADR5(RdAddress[1]), .ADR4(RdAddress[0]), .ADR3(scuba_vlo), .ADR2(scuba_vlo), 
        .ADR1(scuba_vlo), .ADR0(scuba_vlo), .CER(RdClockEn), .OCER(RdClockEn), 
        .CLKR(RdClock), .CSR2(scuba_vlo), .CSR1(scuba_vlo), .CSR0(scuba_vlo), 
        .RST(Reset), .DO17(Q[62]), .DO16(Q[61]), .DO15(Q[60]), .DO14(Q[59]), 
        .DO13(Q[58]), .DO12(Q[57]), .DO11(Q[56]), .DO10(Q[55]), .DO9(Q[54]), 
        .DO8(Q[71]), .DO7(Q[70]), .DO6(Q[69]), .DO5(Q[68]), .DO4(Q[67]), 
        .DO3(Q[66]), .DO2(Q[65]), .DO1(Q[64]), .DO0(Q[63]))
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr73416734161188786e__PMIP__16__73__73B" */
             /* synthesis MEM_INIT_FILE="" */;

    VHI scuba_vhi_inst (.Z(scuba_vhi));

    VLO scuba_vlo_inst (.Z(scuba_vlo));

    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_4_0.INIT_DATA = "STATIC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_4_0.ASYNC_RESET_RELEASE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_4_0.CSDECODE_R = "0b000" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_4_0.CSDECODE_W = "0b001" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_4_0.GSR = "ENABLED" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_4_0.RESETMODE = "ASYNC" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_4_0.REGMODE = "OUTREG" ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_4_0.DATA_WIDTH_R = 18 ;
    defparam pmi_ram_dpXbnonesadr73416734161188786e_0_4_0.DATA_WIDTH_W = 18 ;
    PDPW8KC pmi_ram_dpXbnonesadr73416734161188786e_0_4_0 (.DI17(scuba_vlo), 
        .DI16(scuba_vlo), .DI15(scuba_vlo), .DI14(scuba_vlo), .DI13(scuba_vlo), 
        .DI12(scuba_vlo), .DI11(scuba_vlo), .DI10(scuba_vlo), .DI9(scuba_vlo), 
        .DI8(scuba_vlo), .DI7(scuba_vlo), .DI6(scuba_vlo), .DI5(scuba_vlo), 
        .DI4(scuba_vlo), .DI3(scuba_vlo), .DI2(scuba_vlo), .DI1(scuba_vlo), 
        .DI0(Data[72]), .ADW8(scuba_vlo), .ADW7(scuba_vlo), .ADW6(scuba_vlo), 
        .ADW5(scuba_vlo), .ADW4(scuba_vlo), .ADW3(WrAddress[3]), .ADW2(WrAddress[2]), 
        .ADW1(WrAddress[1]), .ADW0(WrAddress[0]), .BE1(scuba_vhi), .BE0(scuba_vhi), 
        .CEW(WrClockEn), .CLKW(WrClock), .CSW2(scuba_vlo), .CSW1(scuba_vlo), 
        .CSW0(WE), .ADR12(scuba_vlo), .ADR11(scuba_vlo), .ADR10(scuba_vlo), 
        .ADR9(scuba_vlo), .ADR8(scuba_vlo), .ADR7(RdAddress[3]), .ADR6(RdAddress[2]), 
        .ADR5(RdAddress[1]), .ADR4(RdAddress[0]), .ADR3(scuba_vlo), .ADR2(scuba_vlo), 
        .ADR1(scuba_vlo), .ADR0(scuba_vlo), .CER(RdClockEn), .OCER(RdClockEn), 
        .CLKR(RdClock), .CSR2(scuba_vlo), .CSR1(scuba_vlo), .CSR0(scuba_vlo), 
        .RST(Reset), .DO17(), .DO16(), .DO15(), .DO14(), .DO13(), .DO12(), 
        .DO11(), .DO10(), .DO9(Q[72]), .DO8(), .DO7(), .DO6(), .DO5(), .DO4(), 
        .DO3(), .DO2(), .DO1(), .DO0())
             /* synthesis MEM_LPC_FILE="pmi_ram_dpXbnonesadr73416734161188786e__PMIP__16__73__73B" */
             /* synthesis MEM_INIT_FILE="" */;



    // exemplar begin
    // exemplar attribute pmi_ram_dpXbnonesadr73416734161188786e_0_0_4 MEM_LPC_FILE pmi_ram_dpXbnonesadr73416734161188786e__PMIP__16__73__73B
    // exemplar attribute pmi_ram_dpXbnonesadr73416734161188786e_0_0_4 MEM_INIT_FILE 
    // exemplar attribute pmi_ram_dpXbnonesadr73416734161188786e_0_1_3 MEM_LPC_FILE pmi_ram_dpXbnonesadr73416734161188786e__PMIP__16__73__73B
    // exemplar attribute pmi_ram_dpXbnonesadr73416734161188786e_0_1_3 MEM_INIT_FILE 
    // exemplar attribute pmi_ram_dpXbnonesadr73416734161188786e_0_2_2 MEM_LPC_FILE pmi_ram_dpXbnonesadr73416734161188786e__PMIP__16__73__73B
    // exemplar attribute pmi_ram_dpXbnonesadr73416734161188786e_0_2_2 MEM_INIT_FILE 
    // exemplar attribute pmi_ram_dpXbnonesadr73416734161188786e_0_3_1 MEM_LPC_FILE pmi_ram_dpXbnonesadr73416734161188786e__PMIP__16__73__73B
    // exemplar attribute pmi_ram_dpXbnonesadr73416734161188786e_0_3_1 MEM_INIT_FILE 
    // exemplar attribute pmi_ram_dpXbnonesadr73416734161188786e_0_4_0 MEM_LPC_FILE pmi_ram_dpXbnonesadr73416734161188786e__PMIP__16__73__73B
    // exemplar attribute pmi_ram_dpXbnonesadr73416734161188786e_0_4_0 MEM_INIT_FILE 
    // exemplar end

endmodule
